Index: trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMSettingsNetwork.ui
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMSettingsNetwork.ui	(revision 22230)
+++ trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMSettingsNetwork.ui	(revision 22960)
@@ -23,10 +23,10 @@
     <x>0</x>
     <y>0</y>
-    <width>350</width>
-    <height>200</height>
+    <width>431</width>
+    <height>248</height>
    </rect>
   </property>
-  <layout class="QGridLayout" >
-   <item row="0" column="0" colspan="3" >
+  <layout class="QGridLayout" name="VBoxVMSettingsNetworkGridLayout">
+   <item row="0" column="0" colspan="2">
     <widget class="QCheckBox" name="mGbAdapter" >
      <property name="whatsThis" >
@@ -41,13 +41,189 @@
     </widget>
    </item>
-   <item row="1" column="0" >
-    <spacer>
-     <property name="orientation" >
+   <item row="1" column="1" >
+    <widget class="QWidget" name="mNetworkChild" native="true">
+     <layout class="QGridLayout" name="mNetworkChildGridLayout">
+      <property name="margin">
+       <number>0</number>
+      </property>
+      <item row="0" column="0" >
+       <widget class="QLabel" name="mLbNAType">
+        <property name="text" >
+         <string>&amp;Attached to:</string>
+        </property>
+        <property name="alignment" >
+         <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
+        </property>
+        <property name="buddy" >
+         <cstring>mCbAttachmentType</cstring>
+        </property>
+       </widget>
+      </item>
+      <item row="0" column="1" colspan="2" >
+       <widget class="QComboBox" name="mCbAttachmentType">
+        <property name="whatsThis" >
+         <string>Controls how this virtual adapter is attached to the real network of the Host OS.</string>
+        </property>
+       </widget>
+      </item>
+      <item row="1" column="0" >
+       <widget class="QLabel" name="mLbName">
+        <property name="text" >
+         <string>&amp;Name:</string>
+        </property>
+        <property name="alignment" >
+         <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
+        </property>
+        <property name="buddy" >
+         <cstring>mCbName</cstring>
+        </property>
+       </widget>
+      </item>
+      <item row="1" column="1" colspan="2">
+       <widget class="QComboBox" name="mCbName">
+        <property name="whatsThis" >
+         <string>Selects the name of the network adapter if attachment type is equivalent to &lt;b&gt;Bridged Adapter&lt;/b&gt; or &lt;b&gt;Host-only Adapter&lt;/b&gt; and the name of the internal network if attachment type is equivalent to &lt;b&gt;Internal Network&lt;/b&gt;.</string>
+        </property>
+       </widget>
+      </item>
+      <item row="0" column="3" rowspan="3">
+       <spacer name="horizontalSpacer6">
+        <property name="orientation">
+         <enum>Qt::Horizontal</enum>
+        </property>
+        <property name="sizeHint" stdset="0">
+         <size>
+          <width>40</width>
+          <height>20</height>
+         </size>
+        </property>
+       </spacer>
+      </item>
+     </layout>
+    </widget>
+   </item>
+   <item row="2" column="1">
+    <widget class="QWidget" name="mNetworkChild2" native="true">
+     <layout class="QGridLayout" name="mNetworkChild2GridLayout">
+      <property name="topMargin">
+       <number>0</number>
+      </property>
+      <item row="0" column="0">
+       <widget class="QLabel" name="mLbAType">
+        <property name="text">
+         <string>Adapter &amp;Type:</string>
+        </property>
+        <property name="alignment">
+         <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
+        </property>
+        <property name="buddy">
+         <cstring>mCbAdapterType</cstring>
+        </property>
+       </widget>
+      </item>
+      <item row="1" column="0" colspan="2">
+       <widget class="QLabel" name="mLbMAC">
+        <property name="enabled">
+         <bool>true</bool>
+        </property>
+        <property name="text">
+         <string>&amp;Mac Address:</string>
+        </property>
+        <property name="buddy">
+         <cstring>mLeMAC</cstring>
+        </property>
+       </widget>
+      </item>
+      <item row="1" column="2">
+       <widget class="QILineEdit" name="mLeMAC">
+        <property name="sizePolicy">
+         <sizepolicy hsizetype="Fixed" vsizetype="Fixed">
+          <horstretch>0</horstretch>
+          <verstretch>0</verstretch>
+         </sizepolicy>
+        </property>
+        <property name="maximumSize">
+         <size>
+          <width>110</width>
+          <height>22</height>
+         </size>
+        </property>
+        <property name="toolTip">
+         <string>Displays the MAC address of this adapter. It contains exactly 12 characters chosen from {0-9,A-F}. Note that the second character must be an even digit.</string>
+        </property>
+        <property name="frame">
+         <bool>true</bool>
+        </property>
+       </widget>
+      </item>
+      <item row="1" column="3">
+       <widget class="QToolButton" name="mTbMAC">
+        <property name="toolTip">
+         <string>Generates a new random MAC address.</string>
+        </property>
+        <property name="icon">
+         <iconset resource="../VirtualBox.qrc">
+          <normaloff>:/refresh_16px.png</normaloff>:/refresh_16px.png</iconset>
+        </property>
+        <property name="autoRaise">
+         <bool>true</bool>
+        </property>
+       </widget>
+      </item>
+      <item row="2" column="2" colspan="2">
+       <widget class="QCheckBox" name="mCbCable">
+        <property name="toolTip">
+         <string>Indicates whether the virtual network cable is plugged in on machine startup or not.</string>
+        </property>
+        <property name="text">
+         <string>&amp;Cable connected</string>
+        </property>
+       </widget>
+      </item>
+      <item row="0" column="2" colspan="3">
+       <widget class="QComboBox" name="mCbAdapterType">
+        <property name="whatsThis">
+         <string>Selects the type of the virtual network adapter. Depending on this value, VirtualBox will provide different network hardware to the virtual machine.</string>
+        </property>
+       </widget>
+      </item>
+      <item row="0" column="5" rowspan="3">
+       <spacer name="horizontalSpacer_2">
+        <property name="orientation">
+         <enum>Qt::Horizontal</enum>
+        </property>
+        <property name="sizeHint" stdset="0">
+         <size>
+          <width>40</width>
+          <height>20</height>
+         </size>
+        </property>
+       </spacer>
+      </item>
+      <item row="1" column="4">
+       <spacer name="horizontalSpacer_3">
+        <property name="orientation">
+         <enum>Qt::Horizontal</enum>
+        </property>
+        <property name="sizeHint" stdset="0">
+         <size>
+          <width>40</width>
+          <height>20</height>
+         </size>
+        </property>
+       </spacer>
+      </item>
+     </layout>
+    </widget>
+   </item>
+   <item row="1" column="0" rowspan="2">
+    <spacer name="horizontalSpacer2">
+     <property name="orientation">
       <enum>Qt::Horizontal</enum>
      </property>
-     <property name="sizeType" >
+     <property name="sizeType">
       <enum>QSizePolicy::Fixed</enum>
      </property>
-     <property name="sizeHint" >
+     <property name="sizeHint" stdset="0">
       <size>
        <width>20</width>
@@ -57,111 +233,10 @@
     </spacer>
    </item>
-   <item row="1" column="1" >
-    <widget class="QWidget" native="1" name="mNetworkChild" >
-     <layout class="QGridLayout" >
-      <property name="leftMargin" >
-       <number>0</number>
-      </property>
-      <property name="topMargin" >
-       <number>0</number>
-      </property>
-      <property name="rightMargin" >
-       <number>0</number>
-      </property>
-      <property name="bottomMargin" >
-       <number>0</number>
-      </property>
-      <item row="0" column="0" >
-       <widget class="QLabel" name="mLbAType" >
-        <property name="text" >
-         <string>Adapter &amp;Type:</string>
-        </property>
-        <property name="alignment" >
-         <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
-        </property>
-        <property name="buddy" >
-         <cstring>mCbAdapterType</cstring>
-        </property>
-       </widget>
-      </item>
-      <item row="0" column="1" colspan="2" >
-       <widget class="QComboBox" name="mCbAdapterType" >
-        <property name="whatsThis" >
-         <string>Selects the type of the virtual network adapter. Depending on this value, VirtualBox will provide different network hardware to the virtual machine.</string>
-        </property>
-       </widget>
-      </item>
-      <item row="1" column="0" >
-       <widget class="QLabel" name="mLbNAType" >
-        <property name="text" >
-         <string>&amp;Attached to:</string>
-        </property>
-        <property name="alignment" >
-         <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
-        </property>
-        <property name="buddy" >
-         <cstring>mCbAttachmentType</cstring>
-        </property>
-       </widget>
-      </item>
-      <item row="1" column="1" >
-       <widget class="QComboBox" name="mCbAttachmentType" >
-        <property name="whatsThis" >
-         <string>Controls how this virtual adapter is attached to the real network of the Host OS.</string>
-        </property>
-       </widget>
-      </item>
-      <item row="1" column="2" >
-       <widget class="QToolButton" name="mTbDetails" >
-        <property name="whatsThis" >
-         <string>Open additional options dialog for current attachment type.</string>
-        </property>
-        <property name="autoRaise" >
-         <bool>true</bool>
-        </property>
-       </widget>
-      </item>
-      <item row="2" column="0" >
-       <widget class="QLabel" name="mLbName" >
-        <property name="text" >
-         <string>&amp;Name:</string>
-        </property>
-        <property name="alignment" >
-         <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
-        </property>
-        <property name="buddy" >
-         <cstring>mCbName</cstring>
-        </property>
-       </widget>
-      </item>
-      <item row="2" column="1" colspan="2" >
-       <widget class="QComboBox" name="mCbName" >
-        <property name="whatsThis" >
-         <string>Selects the name of the network adapter if attachment type is equivalent to &lt;b>Bridged Adapter&lt;/b> or &lt;b>Host-only Adapter&lt;/b> and the name of the internal network if attachment type is equivalent to &lt;b>Internal Network&lt;/b>.</string>
-        </property>
-       </widget>
-      </item>
-     </layout>
-    </widget>
-   </item>
-   <item row="2" column="0" colspan="3" >
-    <spacer name="verticalSpacer" >
-     <property name="orientation" >
-      <enum>Qt::Vertical</enum>
-     </property>
-     <property name="sizeHint" >
-      <size>
-       <width>20</width>
-       <height>40</height>
-      </size>
-     </property>
-    </spacer>
-   </item>
-   <item row="1" column="2" >
-    <spacer>
-     <property name="orientation" >
+   <item row="1" column="2" rowspan="2">
+    <spacer name="horizontalSpacer4">
+     <property name="orientation">
       <enum>Qt::Horizontal</enum>
      </property>
-        <property name="sizeHint" >
+     <property name="sizeHint" stdset="0">
       <size>
        <width>0</width>
@@ -171,7 +246,29 @@
     </spacer>
    </item>
+   <item row="3" column="1">
+    <spacer name="verticalSpacer2">
+     <property name="orientation">
+      <enum>Qt::Vertical</enum>
+     </property>
+     <property name="sizeHint" stdset="0">
+      <size>
+       <width>0</width>
+       <height>0</height>
+      </size>
+     </property>
+    </spacer>
+   </item>
   </layout>
  </widget>
- <resources/>
+ <customwidgets>
+  <customwidget>
+   <class>QILineEdit</class>
+   <extends>QLineEdit</extends>
+   <header>QILineEdit.h</header>
+  </customwidget>
+ </customwidgets>
+ <resources>
+  <include location="../VirtualBox.qrc"/>
+ </resources>
  <connections>
   <connection>
@@ -181,11 +278,27 @@
    <slot>setEnabled(bool)</slot>
    <hints>
-    <hint type="sourcelabel" >
-     <x>190</x>
-     <y>19</y>
+    <hint type="sourcelabel">
+     <x>184</x>
+     <y>28</y>
     </hint>
-    <hint type="destinationlabel" >
-     <x>203</x>
-     <y>164</y>
+    <hint type="destinationlabel">
+     <x>196</x>
+     <y>111</y>
+    </hint>
+   </hints>
+  </connection>
+  <connection>
+   <sender>mGbAdapter</sender>
+   <signal>toggled(bool)</signal>
+   <receiver>mNetworkChild2</receiver>
+   <slot>setEnabled(bool)</slot>
+   <hints>
+    <hint type="sourcelabel">
+     <x>52</x>
+     <y>17</y>
+    </hint>
+    <hint type="destinationlabel">
+     <x>49</x>
+     <y>147</y>
     </hint>
    </hints>
Index: trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMSettingsNetworkDetails.ui
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMSettingsNetworkDetails.ui	(revision 22230)
+++ 	(revision )
@@ -1,151 +1,0 @@
-<ui version="4.0" >
- <comment>
- VBox frontends: Qt4 GUI ("VirtualBox"):
-
- Copyright (C) 2009 Sun Microsystems, Inc.
-
- This file is part of VirtualBox Open Source Edition (OSE), as
- available from http://www.virtualbox.org. This file is free software;
- you can redistribute it and/or modify it under the terms of the GNU
- General Public License (GPL) as published by the Free Software
- Foundation, in version 2 as it comes in the "COPYING" file of the
- VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
-
- Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
- Clara, CA 95054 USA or visit http://www.sun.com if you need
- additional information or have any questions.
- </comment>
- <class>VBoxVMSettingsNetworkDetails</class>
- <widget class="QWidget" name="VBoxVMSettingsNetworkDetails" >
-  <property name="geometry" >
-   <rect>
-    <x>0</x>
-    <y>0</y>
-    <width>300</width>
-    <height>140</height>
-   </rect>
-  </property>
-  <property name="windowTitle" >
-   <string>Additional Options</string>
-  </property>
-  <layout class="QGridLayout" >
-   <item row="0" column="0" >
-    <widget class="QLabel" name="mLbMAC" >
-     <property name="text" >
-      <string>Guest &amp;MAC Address:</string>
-     </property>
-     <property name="alignment" >
-      <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
-     </property>
-     <property name="buddy" >
-      <cstring>mLeMAC</cstring>
-     </property>
-    </widget>
-   </item>
-   <item row="0" column="1" >
-    <widget class="QILineEdit" name="mLeMAC" >
-     <property name="sizePolicy" >
-      <sizepolicy vsizetype="Fixed" hsizetype="Expanding" >
-       <horstretch>0</horstretch>
-       <verstretch>0</verstretch>
-      </sizepolicy>
-     </property>
-     <property name="toolTip" >
-      <string>Displays the MAC address of this adapter. It contains exactly 12 characters chosen from {0-9,A-F}. Note that the second character must be an even digit.</string>
-     </property>
-    </widget>
-   </item>
-   <item row="0" column="2" >
-    <widget class="QToolButton" name="mTbMAC" >
-     <property name="toolTip" >
-      <string>Generates a new random MAC address.</string>
-     </property>
-     <property name="icon" >
-      <iconset resource="../VirtualBox.qrc" >:/refresh_16px.png</iconset>
-     </property>
-     <property name="autoRaise" >
-      <bool>true</bool>
-     </property>
-    </widget>
-   </item>
-   <item row="1" column="1" colspan="2" >
-    <widget class="QCheckBox" name="mCbCable" >
-     <property name="text" >
-      <string>&amp;Cable connected</string>
-     </property>
-     <property name="toolTip" >
-      <string>Indicates whether the virtual network cable is plugged in on machine startup or not.</string>
-     </property>
-    </widget>
-   </item>
-   <item row="2" column="0" colspan="3" >
-    <spacer name="verticalSpacer" >
-     <property name="orientation" >
-      <enum>Qt::Vertical</enum>
-     </property>
-     <property name="sizeHint" stdset="0" >
-      <size>
-       <width>0</width>
-       <height>0</height>
-      </size>
-     </property>
-    </spacer>
-   </item>
-   <item row="3" column="0" colspan="3" >
-    <widget class="QIDialogButtonBox" name="mButtonBox" >
-     <property name="standardButtons" >
-      <set>QDialogButtonBox::Cancel|QDialogButtonBox::NoButton|QDialogButtonBox::Ok</set>
-     </property>
-    </widget>
-   </item>
-  </layout>
- </widget>
- <customwidgets>
-  <customwidget>
-   <class>QILineEdit</class>
-   <extends>QLineEdit</extends>
-   <header>QILineEdit.h</header>
-  </customwidget>
-  <customwidget>
-   <class>QIDialogButtonBox</class>
-   <extends>QDialogButtonBox</extends>
-   <header>QIDialogButtonBox.h</header>
-  </customwidget>
- </customwidgets>
- <resources/>
- <connections>
-  <connection>
-   <sender>mButtonBox</sender>
-   <signal>accepted()</signal>
-   <receiver>VBoxVMSettingsNetworkDetails</receiver>
-   <slot>accept()</slot>
-   <hints>
-    <hint type="sourcelabel" >
-     <x>162</x>
-     <y>339</y>
-    </hint>
-    <hint type="destinationlabel" >
-     <x>162</x>
-     <y>179</y>
-    </hint>
-   </hints>
-  </connection>
-  <connection>
-   <sender>mButtonBox</sender>
-   <signal>rejected()</signal>
-   <receiver>VBoxVMSettingsNetworkDetails</receiver>
-   <slot>reject()</slot>
-   <hints>
-    <hint type="sourcelabel" >
-     <x>162</x>
-     <y>339</y>
-    </hint>
-    <hint type="destinationlabel" >
-     <x>162</x>
-     <y>179</y>
-    </hint>
-   </hints>
-  </connection>
- </connections>
-</ui>